
mydata <- read.xlsx("correctFull.xlsx", 1)

snippets=colnames(mydata)[2:41]
menWomenTable=matrix(ncol=2,nrow=40,0)

for (i in 2:41){
  
 
  
  temp=mydata[which(mydata$gender=="male" & is.na(mydata[,i])==FALSE),i]
  #plot(density(log(temp)))
  assign(paste("m_snippet", i, sep = ""), temp ) 
  
  temp=mydata[which(mydata$gender=="female" & is.na(mydata[,i])==FALSE),i]
  #plot(density(log(temp)))
  assign(paste("w_snippet", i, sep = ""), temp ) 
  
}

vec=numeric(0)
for (i in 2:41){
  temp1=get(paste("m_snippet", i, sep = "")  )
  temp2=get(paste("w_snippet", i, sep = "")  )
  #print(c(length(temp1),length(temp2)))
  #print(choose(length(temp1)+length(temp2),length(temp1)))
  if(length(temp1)+length(temp2)<20){
    #print(i)
    next
  }
  vec=c(vec,length(temp1)/length(temp2) ) 
  
}

##########################################
#########################################3
permuteForT<-function(men,women){
  concatenate=c(temp1,temp2)
  n=length(concatenate)
  concatenate=concatenate[sample(1:n,n,replace = FALSE)]
  temp_m=concatenate[1:length(men)]
  temp_w=concatenate[(length(men)+1):(length(men)+length(women))]
  Test1=welch(temp_m,temp_w)
  return(Test1)
}

##########################################
#########################################

welch<-function(data1,data2){
  m1=mean(data1)
  m2=mean(data2)
  v1=var(data1)
  v2=var(data2)
  
  t=(m1-m2)/sqrt(v1/length(data1)+v2/length(data2))
}



############################################
############################################
mat=matrix(nrow=10000,ncol=0)
mat2=matrix(nrow=1, ncol=0)
alpha=matrix(nrow=1,ncol=0)
df=matrix(nrow=1,ncol=0)
tDist=matrix(nrow=1,ncol=0)
names=matrix(nrow=1,ncol=0)

mean1=matrix(nrow=1,ncol=0)
mean2=matrix(nrow=1,ncol=0)
std1=matrix(nrow=1,ncol=0)
std2=matrix(nrow=1,ncol=0)

num1=matrix(nrow=1,ncol=0)
num2=matrix(nrow=1,ncol=0)
for (i in 2:41){
  
  #if (i==5 | i==8 | i==10 | i==13 | i==30 | i==31 ){
  #  next
  #}
  
  
  names=c(names, colnames(mydata)[i])
  temp1=get(paste("m_snippet", i, sep = "")  )
  temp2=get(paste("w_snippet", i, sep = "")  )
  num1=c(num1,length(temp1))
  num2=c(num2,length(temp2))
  
  t=welch(temp1,temp2)
  
  
  ############
  dftemp=((var(temp1)/length(temp1)+var(temp2)/length(temp2))^2)/( (var(temp1)/length(temp1))^2/(length(temp1)-1)+  (var(temp2)/length(temp2))^2/(length(temp2)-1)  )
  df=c(df,dftemp)
  tempT=2*pt(-abs(t), dftemp)
  tDist=c(tDist,tempT)
  #############
  
  
  ############
  mean1=c(mean1,mean(temp1))
  mean2=c(mean2,mean(temp2))
  std1=c(std1,sd(temp1))
  std2=c(std2,sd(temp2))
  ##############
  
  mat2=cbind(mat2,t)
  
  vec=numeric(10^4)
  
  for (j in 1:10000){
    vec[j]=permuteForT(temp1,temp2)
  }
  
  mat<-cbind(mat,vec)
  permVec=vec
  
  
  conc=c(temp1,temp2)
  n=length(conc)
  
  vec=numeric(5000)
  
  for (j in 1:5000){
    
    conc=conc[sample(1:n,n,replace = FALSE)]
    
    temp_m=conc[1:length(temp1)]
    temp_w=conc[(length(temp1)+1):(length(temp1)+length(temp2))]
    
    vec[j]=sum(temp_m)
  }  
  
  hh=density(permVec)
  
  
  pval=integrate.xy(hh$x, hh$y,abs(t),max(hh$x))+integrate.xy(hh$x, hh$y,min(hh$x),-abs(t)) 
  alpha=c(alpha,pval)
  
  plot(density(permVec))
  
  
}

for (i in 1:dim(mat)[2]){
  plot(density(mat[,i]))
  abline(v=mat2[i], col="blue")
  abline(v=-mat2[i], col="blue")
}


finalMatrix=cbind(names,num1,round(mean1,1),round(std1,1),num2,round(mean2,1),round(std2,1),round(alpha,2),round(tDist,2))
colnames(finalMatrix)<-c('snippet and size', 'men_N' ,'men_avg' ,'men_stdv', 'women_N' ,'women_avg' ,'women_stdv', 'permut', 't-test')
table5=finalMatrix