
install.packages('eRm')
library('eRm')



wrong=read.table("C:\\Users\\User\\Desktop\\papers\\WW\\dror\\wrong.csv", header = TRUE, sep = ",") 
correct=read.table("C:\\Users\\User\\Desktop\\papers\\WW\\dror\\correct.csv", header = TRUE, sep = ",")

allAnswers=as.matrix(correct)
allAnswers[which(is.na(correct)==FALSE,arr.ind=T)]<-1
allAnswers[which(is.na(wrong)==FALSE,arr.ind=T)]<-0
allAnswers<-allAnswers[,-1]



for (i in 1:40){
  correctans=length(which((allAnswers[,i])==1))
  wrongans  =length(which((allAnswers[,i])==0))
  print( paste( colnames(allAnswers)[i], correctans, wrongans )     )
  
}




num11=dim(allAnswers)
num11=num11[1]


vec=matrix(nrow=num11,ncol=1)
for (i in 1:num11){
   vec[i]=length(which(is.na(allAnswers[i,])==FALSE))
  }
allAnswers<-allAnswers[-which(vec==1),]
v=colnames(allAnswers)
allAnswers<-allAnswers[,-which(v=="two.aStructure")]

rm=RM(allAnswers)
covr=vcov(rm)



betahat=as.matrix(rm$beta)
rwnm=rownames(betahat)
rwnm=rwnm[-1]
betahat=betahat[-1]

ctrsMat=matrix(nrow=0,ncol=4)
colnames(ctrsMat)<-c("contrast","pval","wrongAnswerRatio1","wrongAnswerSum1","wrongAnswerRatio2","wrongAnswerRatio2")


###################################twoSided contrasts

##{as,al}-{cs,cl}
A1=rep(0,38)

c1=c("beta three.aLogic","beta three.aStructure")
c2=c("beta three.cLogic","beta three.cStructure")
title="{as,al}-{cs,cl}"

for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}
contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)

if (pval>.5){
  pval=1-pval
}
pval=pval*2


rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))




##{as}-{cs}
A1=rep(0,38)

c1=c("beta three.aStructure")
c2=c("beta three.cStructure")
title="{as}-{cs}"

for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}
contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)

if (pval>.5){
  pval=1-pval
}
pval=pval*2


rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))


##{al}-{cl}
A1=rep(0,38)

c1=c("beta three.aLogic")
c2=c("beta three.cLogic")
title="{al}-{cl}"

for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}
contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)

if (pval>.5){
  pval=1-pval
}
pval=pval*2


rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))


##{as,al}-{bs,bl}
A1=rep(0,38)

c1=c("beta three.aLogic","beta three.aStructure")
c2=c("beta three.bLogic","beta three.bStructure")
title="{as,al}-{bs,bl}"

for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}
contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)

if (pval>.5){
  pval=1-pval
}
pval=pval*2


rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))


##{as}-{bs}
A1=rep(0,38)

c1=c("beta three.aStructure")
c2=c("beta three.bStructure")
title="{as}-{bs}"

for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}
contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)

if (pval>.5){
  pval=1-pval
}
pval=pval*2


rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))


##{al}-{bl}
A1=rep(0,38)

c1=c("beta three.aLogic")
c2=c("beta three.bLogic")
title="{al}-{bl}"

for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}
contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)

if (pval>.5){
  pval=1-pval
}
pval=pval*2


rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))

##{an}-{an1,an2}
A1=rep(0,38)

c1=c("beta three.aLogicNegative")
c2=c("beta three.aLogicNegative1","beta three.aLogicNegative2")
title="{an}-{an1,an2}"

for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-.5
}
contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)

if (pval>.5){
  pval=1-pval
}
pval=pval*2


rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))

##{an}-{an1}
A1=rep(0,38)

c1=c("beta three.aLogicNegative")
c2=c("beta three.aLogicNegative1")
title="{an}-{an1}"

for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}
contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)

if (pval>.5){
  pval=1-pval
}
pval=pval*2

rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))


##{an}-{an2}
A1=rep(0,38)

c1=c("beta three.aLogicNegative")
c2=c("beta three.aLogicNegative2")
title="{an}-{an2}"

for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}
contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)

if (pval>.5){
  pval=1-pval
}
pval=pval*2

rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))


##{f*}-{f[]}
A1=rep(0,38)

c1=c("beta three.forArithmetic")
c2=c("beta three.forArray")
title="{f*}-{f[]}"

for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}
contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)

if (pval>.5){
  pval=1-pval
}
pval=pval*2

rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))

##{cl,cs}-{bl,bs}
A1=rep(0,38)

c1=c("beta three.cLogic","beta three.cStructure")
c2=c("beta three.bLogic","beta three.bStructure")
title="{cl,cs}-{bl,bs}"

for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}
contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)

if (pval>.5){
  pval=1-pval
}
pval=pval*2

rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))


##{cl}-{bl}
A1=rep(0,38)

c1=c("beta three.cLogic")
c2=c("beta three.bLogic")
title="{cl}-{bl}"

for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}
contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)

if (pval>.5){
  pval=1-pval
}
pval=pval*2

rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))

##{cs}-{bs}
A1=rep(0,38)

c1=c("beta three.cStructure")
c2=c("beta three.bStructure")
title="{cs}-{bs}"

for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}
contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)

if (pval>.5){
  pval=1-pval
}
pval=pval*2

rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))







##{an1}-{an2}
A1=rep(0,38)

c1=c("beta three.aLogicNegative1")
c2=c("beta three.aLogicNegative2")
title="{an1}-{an2}"

for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}
contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)

if (pval>.5){
  pval=1-pval
}
pval=pval*2

rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))


#################################################################################
#################################################################################
#################################################################################
###############          one sided           ####################################
#################################################################################
#################################################################################

ctrsMat=matrix(nrow=0,ncol=4)
colnames(ctrsMat)<-c("contrast","pval","wrongAnswerRatio1","wrongAnswerRatio2")


#{al,bl,cl}-{as,bs,cs}
A1=rep(0,38)

c1=c("beta three.aLogic","beta three.bLogic","beta three.cLogic")
c2=c("beta three.aStructure","beta three.bStructure","beta three.cStructure")
title="{al,bl,cl}-{as,bs,cs}"
for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}

contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)

rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))


#{al,cl}-{as,cs}
A1=rep(0,38)

c1=c("beta three.aLogic","beta three.cLogic")
c2=c("beta three.aStructure","beta three.cStructure")
title="{al,cl}-{as,cs}"
for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}

contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)


rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))


#{al}-{as}
A1=rep(0,38)

c1=c("beta three.aLogic")
c2=c("beta three.aStructure")
title="{al}-{as}"
for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}

contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)

rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))


#{Cl}-{Cs}
A1=rep(0,38)

c1=c("beta three.cLogic")
c2=c("beta three.cStructure")
title="{cl}-{cs}"
for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}

contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)


rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))

#{bl}-{bs}
A1=rep(0,38)

c1=c("beta three.bLogic")
c2=c("beta three.bStructure")
title="{bl}-{bs}"
for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}

contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)

rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))

#{bl}-{bl1}
A1=rep(0,38)

c1=c("beta three.bLogic")
c2=c("beta three.b1Logic")
title="{bl}-{bl1}"
for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}

contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)


rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))

#{bl}-{al}
A1=rep(0,38)

c1=c("beta three.bLogic")
c2=c("beta three.aLogic")
title="{bl}-{al}"
for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}

contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)


rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))


#{bl}-{cl}
A1=rep(0,38)

c1=c("beta three.bLogic")
c2=c("beta three.cLogic")
title="{bl}-{cl}"
for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}

contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)

rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))


#{an}-{al}
A1=rep(0,38)

c1=c("beta three.aLogicNegative")
c2=c("beta three.aLogic")
title="{an}-{al}"
for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}

contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)


rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))


#{an1}-{al}
A1=rep(0,38)

c1=c("beta three.aLogicNegative1")
c2=c("beta three.aLogic")
title="{an1}-{al}"
for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}

contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)

rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))

#{an2}-{al}
A1=rep(0,38)

c1=c("beta three.aLogicNegative2")
c2=c("beta three.aLogic")
title="{an2}-{al}"
for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}

contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)


rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))

#{an,an1,an2}-{al}
A1=rep(0,38)

c1=c("beta three.aLogicNegative","beta three.aLogicNegative1","beta three.aLogicNegative2")
c2=c("beta three.aLogic")
title="{an,an1,an2}-{al}"
for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1/3
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}

contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)


rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))


#{f*,f[]}-{as,cs}
A1=rep(0,38)

c1=c("beta three.forArithmetic","beta three.forArray")
c2=c("beta three.aStructure","beta three.cStructure")
title="{f*,f[]}-{as,cs}"
for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}

contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)

rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))

#{f*}-{as}
A1=rep(0,38)

c1=c("beta three.forArithmetic")
c2=c("beta three.aStructure")
title="{f*}-{as}"
for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}

contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)


rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))


#{f[]}-{as}
A1=rep(0,38)

c1=c("beta three.forArray")
c2=c("beta three.aStructure")
title="{f[]}-{as}"
for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}

contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)

rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))


#{f*}-{cs}
A1=rep(0,38)

c1=c("beta three.forArithmetic")
c2=c("beta three.cStructure")
title="{f*}-{cs}"
for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}

contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)

rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))

#{f[]}-{cs}
A1=rep(0,38)

c1=c("beta three.forArray")
c2=c("beta three.cStructure")
title="{f[]}-{cs}"
for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}

contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)


rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))





#2-3 contrast
A1=rep(0,38)

c1=c("beta three.aLogic","beta three.aLogicNegative","beta three.aLogicNegative1","beta three.aLogicNegative2","beta three.bLogic","beta three.bStructure","beta three.forArithmetic","beta three.forArray")
c2=c("beta two.aLogic","beta two.aLogicNegative","beta two.aLogicNegative1","beta two.aLogicNegative2","beta two.bLogic","beta two.bStructure","beta two.forArithmetic","beta two.forArray")
title="{seg3}-{seg2}"
for (j in 1:length(c1)){
   A1[which(rwnm==c1[j])]=1
   }
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}

contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)

rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))


#3-4 contrast
A1=rep(0,38)
c1=c("beta four.aLogicNegative","beta four.aLogicNegative1","beta four.aLogicNegative2","beta four.bLogic","beta four.bStructure","beta four.cLogic","beta four.cStructure","beta four.forArithmetic","beta four.forArray","beta four.b1Logic","beta four.aStructure")
c2=c("beta three.aLogicNegative","beta three.aLogicNegative1","beta three.aLogicNegative2","beta three.bLogic","beta three.bStructure","beta three.cLogic","beta three.cStructure","beta three.forArithmetic","beta three.forArray","beta three.b1Logic","beta three.aStructure")
title="{seg4}-{seg3}"
for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}

contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)


rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))



#{sp2-4}-{sp0-1}
A1=rep(0,38)
c1=c("beta special.forArr2","beta special.forArr3","beta special.forArr4" )
c2=c("beta special.forArr0","beta special.forArr1")
title="{sp2-4}-{sp0-1}"
for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1/3
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1/2
}

contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)


rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))


#{sp5-6}-{sp0-1}
A1=rep(0,38)
c1=c("beta special.forArr5","beta special.forArr6" )
c2=c("beta special.forArr0","beta special.forArr1")
title="{sp5-6}-{sp0-1}"
for (j in 1:length(c1)){
  A1[which(rwnm==c1[j])]=1
}
for (j in 1:length(c2)){
  A1[which(rwnm==c2[j])]=-1
}

contrs=-A1%*%betahat*((A1%*%covr%*%A1)^-.5)
pval= pnorm(contrs, mean = 0, sd = 1, lower.tail = FALSE, log.p = FALSE)


rwnm1=vector(length=39)
rwnm1[2:39]=rwnm
rwnm1[1]="nonon"

wrNum1=0
crNum1=0
wrNum2=0
crNum2=0

for (j in 1:length(c1)){
  wrNum1=wrNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==0))
  crNum1=crNum1+length(which(allAnswers[,which(rwnm1==c1[j])]==1))
}

for (j in 1:length(c2)){
  wrNum2=wrNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==0))
  crNum2=crNum2+length(which(allAnswers[,which(rwnm1==c2[j])]==1))
}
rat1=wrNum1/(wrNum1+crNum1)
rat2=wrNum2/(wrNum2+crNum2)
ctrsMat=rbind(ctrsMat,c(title,pval,rat1,(wrNum1+crNum1),rat2,(wrNum2+crNum2)))



